/***************************************************************************/
/* 		This code is part of WWW grabber called pavuk		   */
/*		Copyright (c) 1997 - 2000 Stefan Ondrejicka		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include "config.h"
#include "dlhash.h"
#include "url.h"

unsigned int str_hash_func(size, key)
unsigned int size;
void *key;
{
	unsigned char *p = (unsigned char *)key;
	unsigned int retv = 0;

	while(*p)
	{
		retv = (retv + *p) % size;
		p++;
	}

	return retv;
}

int str_comp_func(key1, key2)
void *key2;
void *key1;
{
	return (!strcmp(key1 , key2));
}

void *url_key_func(key_data)
void *key_data;
{
	url *keyd = (url *)key_data;

	return keyd;
}

unsigned int url_hash_func(size, key)
unsigned int size;
void *key;
{
	url *purl = (url *)key;
	unsigned int retv = 0;
	unsigned char *p;

	p = (unsigned char *) url_get_path(purl);

	while(*p)
	{
		retv = (retv + *p) % size;
		p++;
	}

	return retv;
}

void *fn_key_func(key_data)
void *key_data;
{
	url *keyd = (url *)key_data;

	return url_to_filename(keyd , TRUE);
}

void url_free_func(key_data)
void *key_data;
{
	free_deep_url((url *)key_data);
	free(key_data);
}


