/***************************************************************************/
/* 		This code is part of WWW grabber called pavuk		   */
/*		Copyright (c) 1997 - 2000 Stefan Ondrejicka		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#include "config.h"
#include "gui.h"

#ifdef GTK_FACE
#include <stdio.h>
#include <gdk/gdkkeysyms.h>

#include "gtkmulticol.h"
#include "html.h"
#include "uconfig.h"

#include "mimetype.h"

#include "icons/ok.xpm"
#include "icons/apply.xpm"
#include "icons/common.xpm"
#include "icons/cancel.xpm"

static void CfgLimits(object , func_data)
GtkObject *object;
gpointer func_data;
{
	if (!xget_cfg_values_lim())
	{
		if (cfg.use_prefs)
			cfg_dump_pref();
	}
}

static void limtab_tree(notebook)
GtkWidget *notebook;
{
	GtkWidget *label , *box , *col , *ptab;

	box = gtk_vbox_new(FALSE , 2);
	gtk_widget_show(box);
	label = gtk_label_new(gettext("Tree"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), box , label);

	ptab = gtk_table_new(4 , 3 , FALSE);
	gtk_box_pack_start(GTK_BOX(box) , ptab , GTK_FILL , GTK_FILL , 2);
	gtk_widget_show(ptab);
	
	gui_cfg.cgi_sw = gtk_check_button_new_with_label(
		gettext("Download cgi-generated pages"));
	gtk_widget_show(gui_cfg.cgi_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.cgi_sw , 0 , 2 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.ftpd_sw = gtk_check_button_new_with_label(
		gettext("Recurse through FTP directory"));
	gtk_widget_show(gui_cfg.ftpd_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.ftpd_sw , 0 , 2 , 1 , 2 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.robots_sw = gtk_check_button_new_with_label(
		gettext("Allow \"robots.txt\""));
	gtk_widget_show(gui_cfg.robots_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.robots_sw , 0 , 2 , 2 , 3 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.leaves_sw = gtk_check_button_new_with_label(
		gettext("Don't leave starting site"));
	gtk_widget_show(gui_cfg.leaves_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.leaves_sw , 2 , 4 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.leaved_sw = gtk_check_button_new_with_label(
		gettext("Don't leave starting directory"));
	gtk_widget_show(gui_cfg.leaved_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.leaved_sw , 2 , 4 , 1 , 2 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.ftp_html = gtk_check_button_new_with_label(
		gettext("Process HTML files downloaded over FTP"));
	gtk_widget_show(gui_cfg.ftp_html);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.ftp_html , 2 , 4 , 2 , 3 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	gui_cfg.maxdoc_label = guitl_tab_add_numentry(ptab , 
		gettext("Max. count of documents: ") , 0 , 3 , INT_MAX);

	gui_cfg.maxlev_label = guitl_tab_add_numentry(ptab , 
		gettext("Max. depth of tree: ") , 0 , 4 , USHRT_MAX);

	gui_cfg.leave_level = guitl_tab_add_numentry(ptab , 
		gettext("Max. levels to leave from starting site: ") , 0 , 5 , USHRT_MAX);

	gui_cfg.maxsize_label = guitl_tab_add_numentry(ptab , 
		gettext("Max. document size: ") , 2 , 3 , INT_MAX);

	gui_cfg.min_size = guitl_tab_add_numentry(ptab , 
		gettext("Min. document size: ") , 2 , 4 , INT_MAX);

	gui_cfg.site_level = guitl_tab_add_numentry(ptab , 
		gettext("Max. site levels to leave from starting site: ") , 2 , 5 , INT_MAX);

	ptab = gtk_table_new(2, 2, FALSE);
	gtk_box_pack_start(GTK_BOX(box) , ptab , GTK_FILL , GTK_FILL , 2);
	gtk_widget_show(ptab);

	gui_cfg.subdir_label = guitl_tab_add_path_entry(ptab , 
		gettext("Working subdirectory :") , 0 , 0 , TRUE);

	gui_cfg.en_uexit = guitl_tab_add_entry(ptab , 
		gettext("User condition script: ") , 0 , 1 , FALSE);

	ptab = gtk_frame_new(gettext("Wildcard patterns"));
	gtk_box_pack_start(GTK_BOX(box) , ptab , GTK_FILL , GTK_FILL , 2);
	gtk_widget_show(ptab);

	col = gtk_table_new(4 , 2 , FALSE);
	gtk_container_add(GTK_CONTAINER(ptab) , col);
	gtk_widget_show(col);

	gui_cfg.pattern_label = guitl_tab_add_entry(col , 
		gettext("Documents matching pattern: ") , 0 , 0 , FALSE);

	gui_cfg.skip_pattern = guitl_tab_add_entry(col , 
		gettext("skip: ") , 2 , 0 , FALSE);

	gui_cfg.url_pattern_label = guitl_tab_add_entry(col , 
		gettext("URL matching pattern: ") , 0 , 1 , FALSE);

	gui_cfg.skip_url_pattern = guitl_tab_add_entry(col , 
		gettext("skip: ") , 2 , 1 , FALSE);

#ifdef HAVE_REGEX
	ptab = gtk_frame_new(gettext("RE patterns"));
	gtk_box_pack_start(GTK_BOX(box) , ptab , GTK_FILL , GTK_FILL , 2);
	gtk_widget_show(ptab);

	col = gtk_table_new(4 , 2 , FALSE);
	gtk_container_add(GTK_CONTAINER(ptab) , col);
	gtk_widget_show(col);

	gui_cfg.rpattern = guitl_tab_add_entry(col , 
		gettext("Documents matching pattern: ") , 0 , 0 , FALSE);

	gui_cfg.skip_rpattern = guitl_tab_add_entry(col , 
		gettext("skip: ") , 2 , 0 , FALSE);

	gui_cfg.url_rpattern = guitl_tab_add_entry(col , 
		gettext("URL matching pattern: ") , 0 , 1 , FALSE);

	gui_cfg.url_skip_rpattern = guitl_tab_add_entry(col , 
		gettext("skip: ") , 2 , 1 , FALSE);
#endif
}


static void limtab_hosts(notebook)
GtkWidget *notebook;
{
	GtkWidget *brow , *label , *box , *col, *ptab;

	box = gtk_table_new (2 , 2 , FALSE);
	gtk_widget_show(box);
	label = gtk_label_new(gettext("Hosts"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), box , label);

	col = gtk_table_new(2 , 1 , FALSE);
	gtk_widget_show(col);
	gtk_table_attach(GTK_TABLE(box), col , 0 , 1 , 0 , 1 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  5 , 5);

	gui_cfg.hosts_sw = gtk_check_button_new_with_label(
		gettext("Allow / Disallow sites"));
	gtk_widget_show(gui_cfg.hosts_sw);
	gtk_table_attach(GTK_TABLE(col), gui_cfg.hosts_sw , 0 , 1 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);
	
	brow = guitl_new_edit_list(&gui_cfg.hosts_list , &gui_cfg.hosts_entry ,
		gettext("Site: ") , NULL , NULL , NULL , NULL , TRUE);

	gtk_table_attach(GTK_TABLE(col), brow , 0 , 1 , 1 , 2 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  5 , 5);

	col = gtk_table_new(2 , 1 , FALSE);
	gtk_widget_show(col);
	gtk_table_attach(GTK_TABLE(box), col , 1 , 2 , 0 , 1 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  5 , 5);

	gui_cfg.domain_sw = gtk_check_button_new_with_label(
		gettext("Allow / Disallow domains"));
	gtk_widget_show(gui_cfg.domain_sw);
	gtk_table_attach(GTK_TABLE(col), gui_cfg.domain_sw , 0 , 1 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	brow = guitl_new_edit_list(&gui_cfg.domain_list , &gui_cfg.domain_entry ,
		gettext("Domain: ") , NULL , NULL , NULL , NULL , TRUE);

	gtk_table_attach(GTK_TABLE(col), brow , 0 , 1 , 1 , 2 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  5 , 5);

#ifdef HAVE_REGEX
	ptab = gtk_frame_new(gettext("IP address RE patterns"));
	gtk_table_attach(GTK_TABLE(box), ptab , 0 , 2 , 1 , 2 ,
			GTK_FILL , GTK_FILL,  5 , 5);
	gtk_widget_show(ptab);

	col = gtk_table_new(4 , 1 , FALSE);
	gtk_container_add(GTK_CONTAINER(ptab) , col);
	gtk_widget_show(col);

	gui_cfg.aip = guitl_tab_add_entry(col , 
		gettext("Server IP address matching pattern: ") , 0 , 0 , FALSE);

	gui_cfg.skipip = guitl_tab_add_entry(col , 
		gettext("skip: ") , 2 , 0 , FALSE);
#endif
}

static void limtab_docs(notebook)
GtkWidget *notebook;
{
	GtkWidget *brow , *label , *box , *col;

	box = gtk_table_new(1 , 2 , FALSE);
	gtk_widget_show(box);
	label = gtk_label_new(gettext("Documents"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), box , label);

	col = gtk_table_new(2 , 1 , FALSE);
	gtk_widget_show(col);
	gtk_table_attach(GTK_TABLE(box), col , 0 , 1 , 0 , 1 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  5 , 5);

	gui_cfg.sufix_sw = gtk_check_button_new_with_label(
		gettext("Allow / Disallow suffix"));
	gtk_widget_show(gui_cfg.sufix_sw);
	gtk_table_attach(GTK_TABLE(col), gui_cfg.sufix_sw , 0 , 1 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);
	
	brow = guitl_new_edit_list(&gui_cfg.sufixlist , &gui_cfg.sufix_label ,
		gettext("Suffix: ") , NULL , NULL , NULL , NULL , TRUE);

	gtk_table_attach(GTK_TABLE(col), brow , 0 , 1 , 1 , 2 ,
			GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND ,  5 , 5);

	col = gtk_table_new(2 , 1 , FALSE);
	gtk_widget_show(col);
	gtk_table_attach(GTK_TABLE(box), col , 1 , 2 , 0 , 1 ,
			GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND ,  5 , 5);

	gui_cfg.prefix_sw = gtk_check_button_new_with_label(
		gettext("Allow / Disallow prefix"));
	gtk_widget_show(gui_cfg.prefix_sw);
	gtk_table_attach(GTK_TABLE(col), gui_cfg.prefix_sw , 0 , 1 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  5 , 5);

	brow = guitl_new_edit_list(&gui_cfg.prefixlist , &gui_cfg.prefix_label ,
		gettext("Prefix: ") , NULL , NULL , NULL , NULL , TRUE);

	gtk_table_attach(GTK_TABLE(col), brow , 0 , 1 , 1 , 2 ,
			GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND ,  5 , 5);

}

static void limtab_mime(notebook)
GtkWidget *notebook;
{
	GtkWidget *brow , *label , *box , *swin , *button , *col , *ptab , *arrow;
	GtkWidget *dbutton , *abutton , *cbutton , *mbutton;
	static listanfo p;
	static listanfo e;

	box = gtk_table_new(3 , 1 , FALSE);
	gtk_widget_show(box);
	label = gtk_label_new(gettext("MIME types"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), box , label);

	brow = gtk_table_new(1 , 3 , FALSE);
	gtk_widget_show(brow);
	gtk_container_add(GTK_CONTAINER(box), brow);

	ptab = gtk_table_new(2 , 1 , FALSE);
	gtk_widget_show(ptab);
	gtk_table_attach_defaults(GTK_TABLE(brow), ptab , 0 , 1, 0, 1);

	gui_cfg.mime_sw = gtk_check_button_new_with_label(
		gettext("Allow / Disallow MIME type"));
	gtk_widget_show(gui_cfg.mime_sw);
	gtk_table_attach(GTK_TABLE(ptab), gui_cfg.mime_sw , 0 , 1 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  10 , 5);


	swin = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_table_attach_defaults(GTK_TABLE(ptab), swin , 0 , 1 , 1 , 2);
/*
	gtk_table_attach(GTK_TABLE(ptab), swin , 0 , 1 , 1 , 2 ,
			GTK_FILL | GTK_EXPAND , GTK_FILL | GTK_EXPAND ,  10 , 10);
*/
	gtk_widget_show(swin);

	gui_cfg.amimelist = gtk_clist_new(1);
#ifdef _GTK_FEATURES_1_2
	gtk_clist_set_reorderable(GTK_CLIST(gui_cfg.amimelist) , TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(gui_cfg.amimelist) , 0 , TRUE);
#endif
	gtk_clist_set_selection_mode(GTK_CLIST(gui_cfg.amimelist), GTK_SELECTION_BROWSE);
	gtk_container_add(GTK_CONTAINER(swin), gui_cfg.amimelist);
	gtk_widget_show(gui_cfg.amimelist);


	col = gtk_vbox_new(FALSE , 20);
	gtk_widget_show(col);
	gtk_table_attach(GTK_TABLE(brow), col , 1 , 2 , 0 , 1 ,
			GTK_FILL , GTK_FILL,  10 , 10);

	arrow = gtk_arrow_new(GTK_ARROW_RIGHT , GTK_SHADOW_OUT);
	gtk_widget_show(arrow);
	button = gtk_button_new();
	gtk_container_add(GTK_CONTAINER(button) , arrow);
	gtk_widget_show(button);
	gtk_widget_set_usize(button , 25 , 25);
	gtk_container_add(GTK_CONTAINER(col), button);

	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListDeleteSelected) , 
			(gpointer) gui_cfg.amimelist);

	arrow = gtk_arrow_new(GTK_ARROW_LEFT , GTK_SHADOW_OUT);
	gtk_widget_show(arrow);
	button = gtk_button_new();
	gtk_container_add(GTK_CONTAINER(button) , arrow);
	gtk_widget_show(button);
	gtk_widget_set_usize(button , 25 , 25);
	gtk_container_add(GTK_CONTAINER(col), button);


	col = guitl_new_edit_list(&gui_cfg.mimelist , &gui_cfg.mimet_entry ,
		gettext("Other MIME type: ") , &dbutton , &mbutton , &cbutton , &abutton , FALSE);
	gtk_table_attach_defaults(GTK_TABLE(brow), col , 2 , 3 , 0, 1);

	gtk_signal_connect(GTK_OBJECT(dbutton) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListDeleteSelected) , 
			(gpointer) gui_cfg.amimelist);

	e.list = gui_cfg.amimelist;
	e.entry	= gui_cfg.mimet_entry;

	gtk_signal_connect(GTK_OBJECT(abutton) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListInsertEntry) , 
			(gpointer) &e);

	gtk_signal_connect(GTK_OBJECT(gui_cfg.mimet_entry) , "activate" , 
			GTK_SIGNAL_FUNC(guitl_ListInsertEntry) , 
			(gpointer) &e);

	gtk_signal_connect(GTK_OBJECT(mbutton) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListModifyEntry) , 
			(gpointer) &e);

	gtk_signal_connect(GTK_OBJECT(cbutton) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListClear) , 
			(gpointer) gui_cfg.amimelist);

	gtk_signal_connect(GTK_OBJECT(gui_cfg.amimelist) , "select_row" , 
			GTK_SIGNAL_FUNC(guitl_ListCopyToEntry) , 
			(gpointer) gui_cfg.mimet_entry);

	p.entry = gui_cfg.mimelist;
	p.list = gui_cfg.amimelist;

	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_ListInsertList) , 
			(gpointer) &p);

	FILL_LIST(gui_cfg.mimelist , mimetypes);
}

static void limtab_time(notebook)
GtkWidget *notebook;
{
	GtkWidget *tbox, *box , *col , *label , *frame;

	tbox = gtk_vbox_new(FALSE, 1);
	gtk_widget_show(tbox);
	label = gtk_label_new(gettext("Time"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), tbox , label);

	box = gtk_hbox_new(FALSE , 5);
	gtk_widget_show(box);
	gtk_box_pack_start(GTK_BOX(tbox), box , FALSE, FALSE, 4);
	frame = gtk_frame_new(gettext("Lower document time limit"));
	gtk_widget_show(frame);
	gtk_box_pack_start(GTK_BOX(box), frame , FALSE, FALSE, 4);

	col = guitl_timesel_new(&gui_cfg.btime_cal , &gui_cfg.btime_h_entry ,
			   &gui_cfg.btime_min_entry , 
			   &gui_cfg.btime_mon , &gui_cfg.btime_yentry);
	gtk_container_add(GTK_CONTAINER(frame) , col);

	gui_cfg.btime_sw = gtk_check_button_new_with_label(
		gettext("Check if doc. time newer than this"));
	gtk_widget_show(gui_cfg.btime_sw);
	gtk_box_pack_start(GTK_BOX(col), gui_cfg.btime_sw , FALSE, FALSE, 4);

	frame = gtk_frame_new(gettext("Upper document time limit"));
	gtk_widget_show(frame);
	gtk_box_pack_start(GTK_BOX(box), frame , FALSE, FALSE, 4);

	col = guitl_timesel_new(&gui_cfg.etime_cal , &gui_cfg.etime_h_entry , 
			   &gui_cfg.etime_min_entry ,
			   &gui_cfg.etime_mon , &gui_cfg.etime_yentry);
	gtk_container_add(GTK_CONTAINER(frame) , col);

	gui_cfg.etime_sw = gtk_check_button_new_with_label(
		gettext("Check if doc. time older than this"));
	gtk_widget_show(gui_cfg.etime_sw);
	gtk_box_pack_start(GTK_BOX(col), gui_cfg.etime_sw , FALSE, FALSE, 4);	

	frame = gtk_table_new(3 , 1 , FALSE);
	gtk_box_pack_start(GTK_BOX(tbox), frame , FALSE, FALSE, 4);
	gtk_widget_show(frame);

	gui_cfg.max_time = guitl_tab_add_numentry(frame , 
		gettext("Maximal allowed time of downloading: ") , 0 , 0 , INT_MAX);

	label = gtk_label_new(gettext(" min"));
	gtk_table_attach (GTK_TABLE(frame), label , 2 , 3 , 0 , 1,
		GTK_SHRINK , GTK_FILL, 2 , 2);
	gtk_widget_show(label);
}

static void limtab_html(notebook)
GtkWidget *notebook;
{
	GtkWidget *box , *label , *frame , *check;
	int i,j;
	char pom[100];

	frame = gtk_frame_new(gettext("Select allowed HTML tags and attributes"));
	gtk_widget_show(frame);
	label = gtk_label_new(gettext("HTML"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame , label);


	gui_cfg.html_tags = box = gtk_multicol_new (10);
	gtk_multicol_set_number_of_rows(GTK_MULTICOL(gui_cfg.html_tags) , 14);
	gtk_widget_show(box);
	gtk_container_add(GTK_CONTAINER(frame) , box);

	for (i = 0 ; i < NUM_ELEM(linky) ; i++)
	{
		for(j = 0 ; linky[i].attribs[j].attrib ; j++)
		{
			if (!(linky[i].attribs[j].stat & LINK_STYLE))
			{
				sprintf(pom , gettext("%s of %s") ,
					linky[i].attribs[j].attrib , linky[i].tag);

				check = gtk_check_button_new_with_label(pom);
				gtk_object_set_user_data(GTK_OBJECT(check) , 
					(gpointer)&linky[i].attribs[j].stat);
				gtk_widget_show(check);
				gtk_container_add(GTK_CONTAINER(box) , check);
			}
		}
	}
}

/*** LIMITS CFG ***/
void gui_build_config_limits(popup)
int popup;
{
	GtkWidget *col , *brow , *button , *notebook;

	if (gui_cfg.cfg_limits)
	{
		if (popup)
		{
	 		gtk_widget_show_all(gui_cfg.cfg_limits);
			if (GTK_WIDGET_REALIZED(gui_cfg.cfg_limits))
				gdk_window_raise(gui_cfg.cfg_limits->window);
		}
		return;
	}

	gui_cfg.cfg_limits = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_container_border_width (GTK_CONTAINER (gui_cfg.cfg_limits), 3);
	gtk_window_set_title(GTK_WINDOW(gui_cfg.cfg_limits) , gettext("Pavuk: Limits config"));
	gtk_widget_realize (gui_cfg.cfg_limits);
	gtk_signal_connect (GTK_OBJECT (gui_cfg.cfg_limits), "destroy",
		GTK_SIGNAL_FUNC(gtk_widget_destroyed), &gui_cfg.cfg_limits);

	col = gtk_table_new (2 , 1 , FALSE);
	gtk_container_add (GTK_CONTAINER (gui_cfg.cfg_limits), col);
	gtk_widget_show (col);

	notebook = gtk_notebook_new ();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(notebook) , TRUE);
	gtk_table_attach_defaults (GTK_TABLE (col), notebook , 0 , 1, 0, 1);
	gtk_widget_show (notebook);

	limtab_tree(notebook);
	
	limtab_hosts(notebook);
	
	limtab_docs(notebook);
	
	limtab_mime(notebook);

	limtab_time(notebook);

	limtab_html(notebook);

	brow = gtk_hbutton_box_new ();
	gtk_table_attach (GTK_TABLE (col), brow , 0, 1, 1, 2,
			GTK_EXPAND | GTK_FILL, GTK_FILL, 2 , 5);
	gtk_hbutton_box_set_spacing_default (1);
	gtk_widget_show (brow);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (brow) , GTK_BUTTONBOX_SPREAD);

	button = guitl_pixmap_button(ok_xpm , NULL , gettext("OK"));
	gtk_container_add (GTK_CONTAINER (brow), button);
	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(gui_PopdownWC) , 
			(gpointer)gui_cfg.cfg_limits);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button);
	gtk_widget_show (button);

	button = guitl_pixmap_button(apply_xpm , NULL , gettext("Apply"));
	gtk_container_add (GTK_CONTAINER (brow), button);
	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(CfgLimits) , 
			(gpointer)gui_cfg.config_shell);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show (button);

	button = guitl_pixmap_button(common_xpm , NULL , gettext("Common ..."));
	gtk_container_add (GTK_CONTAINER (brow), button);
	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(gui_PopupW) , 
			(gpointer)PAVUK_CFGCOMM);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show (button);

	button = guitl_pixmap_button(cancel_xpm , NULL , gettext("Cancel"));
#ifdef _GTK_FEATURES_1_2
{
	GtkAccelGroup *accel_group;
	accel_group = gtk_accel_group_new();

	gtk_widget_add_accelerator(button , "clicked" , accel_group ,
			GDK_Escape , 0 , GTK_ACCEL_VISIBLE);

	gtk_window_add_accel_group(GTK_WINDOW(gui_cfg.cfg_limits) , accel_group);
}
#endif
	gtk_container_add (GTK_CONTAINER (brow), button);
	gtk_signal_connect(GTK_OBJECT(button) , "clicked" , 
			GTK_SIGNAL_FUNC(guitl_PopdownW) , 
			(gpointer)gui_cfg.cfg_limits);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show (button);

	if (popup) gtk_widget_show(gui_cfg.cfg_limits);

	xset_cfg_values_lim();
}
 #endif
