/***************************************************************************/
/* 		This code is part of WWW grabber called pavuk		   */
/*		Copyright (c) 1997 - 2000 Stefan Ondrejicka		   */
/*		(ondrej@idata.sk)					   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _tools_h_
#define _tools_h_

#include <time.h>
#include <stdlib.h>
#include <stdarg.h>

typedef unsigned char bool;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif


#define _free(ptr) if(ptr){ free(ptr); ptr = NULL;}

#define NUM_ELEM(x)	((unsigned int) (sizeof(x) / sizeof(x[0])))

extern void strip_nl(char *);
extern void omit_chars(char *, char *);
extern char *upperstr(char *);
extern char *lowerstr(char *);
extern char *new_string(char *);
extern char *new_n_string(char * , int);
extern int makealldirs(char *);
extern char *get_abs_file_path(char *);
extern char *get_abs_file_path_oss(char *);
extern char *get_relative_path(char *,char *);
extern char *get_extension(char *);
extern char **make_list(char *,char *);
extern bool is_in_list(char * , char **);
extern char *get_1qstr(char *);
extern char *strtokc(char * , int);
extern char *strfindnchr(char * , int , int);
extern void *_malloc(int);
extern void *_realloc(void *, int);
extern int my_read(int , char * , int, void *);
extern int my_write(int , char * , int, void *);
extern int _selectr(int , int);
extern int _selectw(int , int);
extern int  get_line(char * , int , int);
extern bool file_is_html(char *);
extern bool ext_is_html(char *);
extern long int _atoi(char *);
extern double _atof(char *);
extern char * _strtrchr(char * , int , int);
extern void xprintf(int , char * , ...);
extern void xdebug(int , char * , ...);
extern void xvadebug(int , char * , va_list *);
extern void xperror(char *);
extern void xherror(char *);
extern int unlink_recursive(char *);
extern unsigned int hash_func(char * , int);
extern int str_is_in_list(int , char * , ...);
extern char *cvt_win32_to_unix_path(char *);
extern int copy_fd_to_file(int , char *);
extern void my_msleep(unsigned int);
extern void pavuk_do_at_exit();
extern char *escape_str(char *, char *);
extern char *tl_adjust_filename(char *);
extern int tl_filename_needs_adjust(char *);
extern int tl_is_dirname(char *);
extern char *tl_str_append(char *, char *);
extern char *tl_str_concat(char *, ...);
extern char *tl_data_concat_data(int *, char *, int, char *);
extern char *tl_data_concat_str(int *, char *, ...);


#ifdef NO_SETENV
extern int my_setenv(char *, char *, int);
#endif

#ifndef I_FACE
#define my_sleep sleep
#else
extern void my_sleep(unsigned int);
#endif

extern int my_flock(int *, char * , int , int);
#ifdef HAVE_FCNTL_FLOCK
extern int my_funlock(int);
#endif


#endif
